package org.gcube.portlets.user.geoportaldataentry.client;

import java.util.List;

import org.gcube.application.geoportalcommon.shared.GeoNaItemRef;
import org.gcube.application.geoportalcommon.shared.ResultSetPaginatedData;
import org.gcube.application.geoportalcommon.shared.SearchingFilter;
import org.gcube.application.geoportalcommon.shared.geoportalconfig.DocumentConfigDV;
import org.gcube.application.geoportalcommon.shared.products.ConcessioneDV;
import org.gcube.application.geoportalcommon.shared.products.content.WorkspaceContentDV;
import org.gcube.application.geoportalcommon.shared.products.paths.FileSetPathsDV;
import org.gcube.portlets.user.geoportaldataentry.client.ConstantsGeoPortalDataEntryApp.RECORD_TYPE;
import org.gcube.portlets.user.geoportaldataentry.shared.CommitReport;
import org.gcube.portlets.user.geoportaldataentry.shared.GNADataEntryExtConfigProfile;
import org.gcube.portlets.user.geoportaldataentry.shared.GeoNaFormDataObject;
import org.gcube.portlets.user.geoportaldataentry.shared.GeonaISConfig;
import org.gcube.portlets.widgets.mpformbuilder.shared.GenericDatasetBean;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;

public interface GeoportalDataEntryServiceAsync {

	/**
	 * Utility class to get the RPC Async interface from client-side code
	 */
	public static final class Util {
		private static GeoportalDataEntryServiceAsync instance;

		public static final GeoportalDataEntryServiceAsync getInstance() {
			if (instance == null) {
				instance = (GeoportalDataEntryServiceAsync) GWT.create(GeoportalDataEntryService.class);
			}
			return instance;
		}

		private Util() {
			// Utility class should not be instantiated
		}
	}

	void saveGeonaDataForms(List<GeoNaFormDataObject> listGeonaFormObjects, AsyncCallback<CommitReport> callback);

	void getGeonaInitConfig(AsyncCallback<GeonaISConfig> callback);

	void getLinksFor(String itemId, RECORD_TYPE recordType, AsyncCallback<GeoNaItemRef> callback);

	void getListConcessioni(Integer start, Integer limit, SearchingFilter filter, boolean reloadFromService,
			AsyncCallback<ResultSetPaginatedData> callback);

	void deleteRecord(String itemId, RECORD_TYPE recordType, AsyncCallback<Boolean> callback);

	void getJSONRecord(String itemId, RECORD_TYPE recordType, AsyncCallback<String> callback);

	void updateRecord(String itemId, String jsonUpdate, RECORD_TYPE recordType, AsyncCallback<ConcessioneDV> callback);

	void readFileSetPaths(AsyncCallback<FileSetPathsDV> callback);

	void getRecord(String itemId, RECORD_TYPE recordType, AsyncCallback<ConcessioneDV> callback);

	void updateSectionForRecord(String itemId, String recordType, String section, int pathIndex,
			List<WorkspaceContentDV> keepCurrentContent, GenericDatasetBean gDBean,
			AsyncCallback<ConcessioneDV> callback);

	void readDataViewerConfig(AsyncCallback<GNADataEntryExtConfigProfile> asyncCallback);

	void getListDocumentConfigurationForId(String id, AsyncCallback<List<DocumentConfigDV>> callback);

}
