package org.gcube.portlets.user.geoportaldataentry.client.events;

import org.gcube.application.geoportalcommon.shared.geoportalconfig.DocumentConfigDV;

import com.google.gwt.event.shared.GwtEvent;

/**
 * The Class CreateNewProjectEvent.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR (francesco.mangiacrapa@isti.cnr.it)
 * 
 * Oct 13, 2020
 */
public class CreateNewProjectEvent extends GwtEvent<CreateNewProjectEventHandler> {
	
	/** The type. */
	public static Type<CreateNewProjectEventHandler> TYPE = new Type<CreateNewProjectEventHandler>();
	private DocumentConfigDV documentConfiguration;

	/**
	 * Instantiates a new cancel upload event.
	 */
	public CreateNewProjectEvent(DocumentConfigDV documentConfiguration) {
		this.documentConfiguration = documentConfiguration;
	}

	/**
	 * Gets the associated type.
	 *
	 * @return the associated type
	 */
	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public Type<CreateNewProjectEventHandler> getAssociatedType() {
		return TYPE;
	}

	/**
	 * Dispatch.
	 *
	 * @param handler the handler
	 */
	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#dispatch(com.google.gwt.event.shared.EventHandler)
	 */
	@Override
	protected void dispatch(CreateNewProjectEventHandler handler) {
		handler.onCreateNewProject(this);
	}
	
	public DocumentConfigDV getDocumentConfiguration() {
		return documentConfiguration;
	}

}
