package org.gcube.portlets.user.geoportaldataentry.shared;

import java.io.Serializable;

/**
 * The Class GeonaISConfig.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR francesco.mangiacrapa@isti.cnr.it
 * 
 *         Dec 22, 2021
 */
public class GeonaISConfig implements Serializable {


	/**
	 * 
	 */
	private static final long serialVersionUID = 4187839053354198268L;
	private String genericResSecondaryType;
	private String scope;

	/**
	 * Instantiates a new geona IS config.
	 */
	public GeonaISConfig() {
	}

	/**
	 * Instantiates a new geona IS config.
	 *
	 * @param gRSecondaryType the g R secondary type
	 * @param scope           the scope
	 */
	public GeonaISConfig(String gRSecondaryType, String scope) {
		super();
		this.genericResSecondaryType = gRSecondaryType;
		this.scope = scope;
	}

	/**
	 * Gets the generic resource secondary type.
	 *
	 * @return the generic resource secondary type
	 */
	public String getGenericResourceSecondaryType() {
		return genericResSecondaryType;
	}

	/**
	 * Sets the generic resource secondary type.
	 *
	 * @param gRSecondaryType the new generic resource secondary type
	 */
	public void setGenericResourceSecondaryType(String gRSecondaryType) {
		this.genericResSecondaryType = gRSecondaryType;
	}

	/**
	 * Gets the scope.
	 *
	 * @return the scope
	 */
	public String getScope() {
		return scope;
	}

	/**
	 * Sets the scope.
	 *
	 * @param scope the new scope
	 */
	public void setScope(String scope) {
		this.scope = scope;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("GeonaISConfig [genericResSecondaryType=");
		builder.append(genericResSecondaryType);
		builder.append(", scope=");
		builder.append(scope);
		builder.append("]");
		return builder.toString();
	}

}
